package envoy.client.ui.renderer;

import javax.swing.JPanel;

import envoy.client.ui.MessageComponent;
import envoy.client.ui.list.ComponentList;
import envoy.client.ui.list.ComponentListCellRenderer;
import envoy.data.Message;

/**
 * Defines how a message is displayed.<br>
 * <br>
 * Project: <strong>envoy-client</strong><br>
 * File: <strong>MessageListRenderer.java</strong><br>
 * Created: <strong>19 Oct 2019</strong><br>
 *
 * @author Kai S. K. Engelbart
 * @author Maximilian K&auml;fer
 * @author Leon Hofmeister
 * @since Envoy v0.1-alpha
 */
public class MessageListRenderer implements ComponentListCellRenderer<Message> {

	private final long senderId;

	/**
	 * Initializes a message list renderer. Messages with the given sender ID will
	 * be aligned on the right side, while all other messages will be aligned on
	 * the left side
	 * 
	 * @param senderId the sender ID of the messages to align on the right side
	 * @since Envoy v0.1-beta
	 */
	public MessageListRenderer(long senderId) { this.senderId = senderId; }

	// TODO: Handle message attachments

	@Override
	public JPanel getListCellComponent(ComponentList<? extends Message> list, Message message, boolean isSelected) {
		return new MessageComponent(list, message, isSelected, senderId);
	}
}
